//+------------------------------------------------------------------+
//|                                                      i-VaR95.mq4 |
//|                                    http://piccstick.blogspot.com |
//|                                    http://piccstick.blogspot.com |
//+------------------------------------------------------------------+
//|              |
//|                    |
//|  - Simple Historical Volatility                                  |
//|  - Exponential Historical Volatility                             |
//|  - High-Low Historical Volatility                                |
//|                                                                  |  
//|  :                                             |
//| 1.                    |
//|        ;-)                                          |
//| 2.       ATR,  |
//|       ,    ,  |
//| 3.   VaR  95- ,       |
//|           (     | 
//|    5- ),                |
//|     5%                   |
//|     (grznt)                                             |
//|                                                                  |
//|                                                                  |   
//|                                                                  |
//|                        |
//|   .                                                    |
//|                                                                  |
//|   .                                                   |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "piccioli@gmail.com"
#property link      "http://piccstick.blogspot.com"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 clrOrangeRed

extern int HV_Period = 21;    //    
extern int HV_Type = 0;       //   
                              //  :
// 0 -   ()  
// 1 -  -  
// 2 -  ,  
//  -       95- VaR (. . )

extern double decline=0.94;   //  
                              //    0.94
//      - ,    HV_Type = 1

extern int grznt=3;           //     95% VaR

double VAR[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE,EMPTY,2,clrOrangeRed);
   SetIndexBuffer(0,VAR);
   SetIndexLabel(0,"VaR");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted();
   int limit;

//----
   if(counted_bars>0) counted_bars=counted_bars-HV_Period;
   limit=Bars-counted_bars;
   if(counted_bars==0)
      limit-=HV_Period;
//----  
   for(int i=0; i<limit; i++)
     {
      VAR[i]=HV(i);
     }

//----
   return(0);
  }
//+------------------------------------------------------------------+

double HV(int j)
  {
   double shv=0;
   double tshv= 0;
   double ehv = 0;
   double hlhv= 0;
   double var95=0;

   for(int i=j; i<(HV_Period+j); i++)
     {
      hlhv=hlhv+(MathLog(iHigh(Symbol(),0,i)/iLow(Symbol(),0,i))*MathLog(iHigh(Symbol(),0,i)/iLow(Symbol(),0,i)))/(4*MathLog(2));
     }

   hlhv=MathSqrt(hlhv/HV_Period);

   for(i=j; i<(HV_Period+j); i++)
     {
      tshv=tshv+MathLog(iClose(Symbol(),0,i)/iClose(Symbol(),0,i+1));
     }

   tshv=tshv/(HV_Period>0 ? HV_Period : 1);

   for(i=j; i<(HV_Period+j); i++)
     {
      shv=shv+(tshv -(MathLog(iClose(Symbol(),0,i)/iClose(Symbol(),0,i+1))))*(tshv -(MathLog(iClose(Symbol(),0,i)/iClose(Symbol(),0,i+1))));
     }

   shv=MathSqrt(shv/((HV_Period-1)>0 ?(HV_Period-1) : 1));

   if(decline>= 1 || decline <= 0)
      decline = 0.94;

   for(i=j; i<(HV_Period+j); i++)
     {
      ehv=ehv+decline*(tshv -(MathLog(iClose(Symbol(),0,i)/iClose(Symbol(),0,i+1))))*(tshv -(MathLog(iClose(Symbol(),0,i)/iClose(Symbol(),0,i+1))));
     }
   ehv=MathSqrt((1-decline)*shv);

   var95=1.65 *(shv)*10000*MathSqrt(grznt)+2*MarketInfo(Symbol(),MODE_SPREAD);

   if(HV_Type==0)
      return(shv);
   else if(HV_Type==1)
      return(ehv);
   else if(HV_Type==2)
      return(hlhv);
   else
      return(MathCeil(var95));
  }
//+------------------------------------------------------------------+
